#########################################################################################
###### Run Analysis
#########################################################################################

firstAnalysis <- TRUE
TEMPChecksums <- list(	Data_input = "imported",
						Data_raw = c("used", "resulting"),
						Data_rawOrig = c("used", "resulting"),
						Data_rawSm = c("used", "resulting"),
						Data_rawSlope = c("used", "resulting"),
						Data_rawSlopeSd = c("used", "resulting"),
						Data_rawCons = c("used", "resulting"),
						Data_rawConsSd = c("used", "resulting"),
						Data_rawAv = c("used", "resulting"),
						Data_rawAvSm = c("used", "resulting"),
						Data_rawAvSlope = c("used", "resulting"),
						Data_rawAvSlopeSd = c("used", "resulting"),
						Data_rawAvCons = c("used", "resulting"),
						Data_rawAvConsSd = c("used", "resulting"),
						Data_rawSd = c("used", "resulting"),
						Data_oxoDish = c("used", "resulting"),
						Data_oxoDishOrig = c("used", "resulting"),
						Data_oxoDishSm = c("used", "resulting"),
						Data_oxoDishSlope = c("used", "resulting"),
						Data_oxoDishSlopeSd = c("used", "resulting"),
						Data_oxoDishCons = c("used", "resulting"),
						Data_oxoDishConsSd = c("used", "resulting"),
						Data_oxoDishAv = c("used", "resulting"),
						Data_oxoDishAvSm = c("used", "resulting"),
						Data_oxoDishAvSlope = c("used", "resulting"),
						Data_oxoDishAvSlopeSd = c("used", "resulting"),
						Data_oxoDishAvCons = c("used", "resulting"),
						Data_oxoDishAvConsSd = c("used", "resulting"),
						Data_oxoDishSd = c("used", "resulting"),
						Data_oxoPlate = c("used", "resulting"),
						Data_oxoPlateOrig = c("used", "resulting"),
						Data_oxoPlateSm = c("used", "resulting"),
						Data_oxoPlateSlope = c("used", "resulting"),
						Data_oxoPlateSlopeSd = c("used", "resulting"),
						Data_oxoPlateCons = c("used", "resulting"),
						Data_oxoPlateConsSd = c("used", "resulting"),
						Data_oxoPlateAv = c("used", "resulting"),
						Data_oxoPlateAvSm = c("used", "resulting"),
						Data_oxoPlateAvSlope = c("used", "resulting"),
						Data_oxoPlateAvSlopeSd = c("used", "resulting"),
						Data_oxoPlateAvCons = c("used", "resulting"),
						Data_oxoPlateAvConsSd = c("used", "resulting"),
						Data_oxoPlateSd = c("used", "resulting"),
						Data_hydroPlate = c("used", "resulting"),
						Data_hydroPlateOrig = c("used", "resulting"),
						Data_hydroPlateCal = c("used", "resulting"),
						Data_hydroPlateSm = c("used", "resulting"),
						Data_hydroPlateSlope = c("used", "resulting"),
						Data_hydroPlateSlopeSd = c("used", "resulting"),
						Data_hydroPlateAv = c("used", "resulting"),
						Data_hydroPlateAvSm = c("used", "resulting"),
						Data_hydroPlateAvSlope = c("used", "resulting"),
						Data_hydroPlateAvSlopeSd = c("used", "resulting"),
						Data_hydroPlateSd = c("used", "resulting"),
						Data_medium = c("used", "resulting"),
						Data_mediumOrig = c("used", "resulting"),
						Data_mediumSm = c("used", "resulting"),
						Data_mediumSlope = c("used", "resulting"),
						Data_mediumSlopeSd = c("used", "resulting"),
						Data_mediumCons = c("used", "resulting"),
						Data_mediumConsSd = c("used", "resulting"),
						Data_mediumAv = c("used", "resulting"),
						Data_mediumAvSm = c("used", "resulting"),
						Data_mediumAvSlope = c("used", "resulting"),
						Data_mediumAvSlopeSd = c("used", "resulting"),
						Data_mediumAvCons = c("used", "resulting"),
						Data_mediumAvConsSd = c("used", "resulting"),
						Data_mediumSd = c("used", "resulting"),
						Data_IC50 = c("used", "resulting"),
						Data_IC50Models = c("used", "resulting") )

#########################################################################################
#### Run Analysis interactive
#########################################################################################

####
#### Signal: Overall Run Analysis button
########################################
gSignalConnect(btnRun, "clicked", after = TRUE, quote({
	## If everything is fine continue with folder name and Analysis 
	if (FCheckBeforeAnalysis() == TRUE) {
		if (FFinalProjectname() == TRUE) {
			FStartAnalysis(rerun = FALSE)
			FRunAnalysis(rerun = FALSE)
			FEndAnalysis()
		}
	}
}))

####
#### Signal: Rerun Formatting
#############################
gSignalConnect(btnFormattingRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the data formatting?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			} else if (length(SETAnalysisOpt$Formatting) != 0) {
				## raw formatting
				if (SETAnalysisOpt$Formatting == "Data_raw") {
					if (length(Data_rawOrig[1,1]) != 0) Data_raw <<- Data_rawOrig
					else {
						Data_rawOrig <<- Data_raw
						TEMPChecksums$Data_rawOrig[1] <<- sum(colSums(Data_input))
						TEMPChecksums$Data_rawOrig[2] <<- sum(colSums(Data_rawOrig))
					}
					FCalculationFormatting(Data_raw)
					Data_raw <<- ResFormat
					TEMPChecksums$Data_raw[2] <<- sum(colSums(Data_raw))
					print("Data raw formatted")
					print(Data_raw[1:10,])
				}
				## oxoDish formatting
				if (SETAnalysisOpt$Formatting == "Data_oxoDish") {
					if (length(Data_oxoDishOrig[1,1]) != 0) Data_oxoDish <<- Data_oxoDishOrig
					else {
						Data_oxoDishOrig <<- Data_oxoDish
						TEMPChecksums$Data_oxoDishOrig[1] <<- sum(colSums(Data_input))
						TEMPChecksums$Data_oxoDishOrig[2] <<- sum(colSums(Data_oxoDishOrig))
					}
					FCalculationFormatting(Data_oxoDish)
					Data_oxoDish <<- ResFormat
					TEMPChecksums$Data_oxoDish[2] <<- sum(colSums(Data_oxoDish))
					print("Data oxoDish formatted")
					print(Data_oxoDish[1:10,])
				}
				## oxoPlate formatting
				if (SETAnalysisOpt$Formatting == "Data_oxoPlate") {
					if (length(Data_oxoPlateOrig[1,1]) != 0) Data_oxoPlate <<- Data_oxoPlateOrig
					else {
						Data_oxoPlateOrig <<- Data_oxoPlate
						TEMPChecksums$Data_oxoPlateOrig[1] <<- sum(colSums(Data_raw))
						TEMPChecksums$Data_oxoPlateOrig[2] <<- sum(colSums(Data_oxoPlateOrig))
					}
					FCalculationFormatting(Data_oxoPlate)
					Data_oxoPlate <<- ResFormat
					TEMPChecksums$Data_oxoPlate[2] <<- sum(colSums(Data_oxoPlate))
					print("Data oxoPlate formatted")
					print(Data_oxoPlate[1:10,])
				}
				## hydroPlate formatting
				if (SETAnalysisOpt$Formatting == "Data_hydroPlate") {
					if (length(Data_hydroPlateOrig[1,1]) != 0) Data_hydroPlate <<- Data_hydroPlateOrig
					else {
						Data_hydroPlateOrig <<- Data_hydroPlate
						TEMPChecksums$Data_hydroPlateOrig[1] <<- sum(colSums(Data_raw))
						TEMPChecksums$Data_hydroPlateOrig[2] <<- sum(colSums(Data_hydroPlateOrig))
					}
					FCalculationFormatting(Data_hydroPlate)
					Data_hydroPlate <<- ResFormat
					TEMPChecksums$Data_hydroPlate[2] <<- sum(colSums(Data_hydroPlate))
					print("Data hydroPlate formatted")
					print(Data_hydroPlate[1:10,])
				}
				## medium formatting
				if (SETAnalysisOpt$Formatting == "Data_medium" & SETAnalysisOpt$oxoDish[1] == TRUE) {
					if (length(Data_mediumOrig[1,1]) != 0) Data_medium <<- Data_mediumOrig
					else {
						Data_mediumOrig <<- Data_medium
						TEMPChecksums$Data_mediumOrig[1] <<- sum(colSums(Data_oxoDish))
						TEMPChecksums$Data_mediumOrig[2] <<- sum(colSums(Data_mediumOrig))
					}
					FCalculationFormatting(Data_medium)
					Data_medium <<- ResFormat
					TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
					print("Data normalisation formatted")
					print(Data_medium[1:10,])
				}
				## medium formatting
				if (SETAnalysisOpt$Formatting == "Data_medium" & SETAnalysisOpt$oxoDish[1] == FALSE) {
					if (length(Data_mediumOrig[1,1]) != 0) Data_medium <<- Data_mediumOrig
					else {
						Data_mediumOrig <<- Data_medium
						TEMPChecksums$Data_mediumOrig[1] <<- sum(colSums(Data_raw))
						TEMPChecksums$Data_mediumOrig[2] <<- sum(colSums(Data_mediumOrig))
					}
					FCalculationFormatting(Data_medium)
					Data_medium <<- ResFormat
					TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
					print("Data normalisation formatted")
					print(Data_medium[1:10,])
				}
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

####
#### Signal: Rerun Medium normalisation
#######################################
gSignalConnect(btnMediumCalRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the normalisation?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			if (SETAnalysisOpt$oxoDish[1] == TRUE) {
				FCalculationMedium(Data_oxoDish)
				TEMPChecksums$Data_medium[1] <- sum(colSums(Data_oxoDish))
				TEMPChecksums$Data_medium[2] <- sum(colSums(Data_medium))
				print("Data normalisation")
				print(Data_medium[1:10,])
			} else {
				FCalculationMedium(Data_raw)
				TEMPChecksums$Data_medium[1] <- sum(colSums(Data_raw))
				TEMPChecksums$Data_medium[2] <- sum(colSums(Data_medium))
				print("Data normalisation")
				print(Data_medium[1:10,])
			}
			Data_mediumOrig <<- data.frame()
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

####
#### Signal: Rerun Average calculation
######################################
gSignalConnect(btnAverageRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the average calculation?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			## raw average
			if (SETAnalysisOpt$raw[2] == TRUE) {
				FCalculationAverage(Data_raw)
				Data_rawAv <- Res
				TEMPChecksums$Data_rawAv[1] <- sum(colSums(Data_raw))
				TEMPChecksums$Data_rawAv[2] <- sum(colSums(Data_rawAv))
				print("Data raw av")
				print(Data_rawAv[1:10,])
				## raw standarddeviation
				if (SETAnalysisOpt$SD == TRUE) {
					FCalculationStandarddev(Data_raw)
					Data_rawSd <- Res
					TEMPChecksums$Data_rawSd[1] <- sum(colSums(Data_raw))
					TEMPChecksums$Data_rawSd[2] <- sum(colSums(Data_rawSd))
					print("Data raw sd")
					print(Data_rawSd[1:10,])
				}
			}
			## OxoDish average
			if (SETAnalysisOpt$oxoDish[2] == TRUE & SETAnalysisOpt$oxoDish[1] == TRUE) {
				FCalculationAverage(Data_oxoDish)
				Data_oxoDishAv <- Res
				TEMPChecksums$Data_oxoDishAv[1] <- sum(colSums(Data_oxoDish))
				TEMPChecksums$Data_oxoDishAv[2] <- sum(colSums(Data_oxoDishAv))
				print("Data oxoDish av")
				print(Data_oxoDishAv[1:10,])
				## OxoDish standarddeviation
				if (SETAnalysisOpt$SD == TRUE) {
					FCalculationStandarddev(Data_oxoDish)
					Data_oxoDishSd <- Res
					TEMPChecksums$Data_oxoDishSd[1] <- sum(colSums(Data_oxoDish))
					TEMPChecksums$Data_oxoDishSd[2] <- sum(colSums(Data_oxoDishSd))
					print("Data oxoDish sd")
					print(Data_oxoDishSd[1:10,])
				}
			}
			## OxoPlate average
			if (SETAnalysisOpt$oxoPlate[2] == TRUE & SETAnalysisOpt$oxoPlate[1] == TRUE) {
				FCalculationAverage(Data_oxoPlate)
				Data_oxoPlateAv <- Res
				TEMPChecksums$Data_oxoPlateAv[1] <- sum(colSums(Data_oxoPlate))
				TEMPChecksums$Data_oxoPlateAv[2] <- sum(colSums(Data_oxoPlateAv))
				print("Data oxoPlate av")
				print(Data_oxoPlateAv[1:10,])
				## OxoPlate standarddeviation
				if (SETAnalysisOpt$SD == TRUE) {
					FCalculationStandarddev(Data_oxoPlate)
					Data_oxoPlateSd <- Res
					TEMPChecksums$Data_oxoPlateSd[1] <- sum(colSums(Data_oxoPlate))
					TEMPChecksums$Data_oxoPlateSd[2] <- sum(colSums(Data_oxoPlateSd))
					print("Data oxoPlate sd")
					print(Data_oxoPlateSd[1:10,])
				}
			}
			## HydroPlate average
			if (SETAnalysisOpt$hydroPlate[2] == TRUE & SETAnalysisOpt$hydroPlate[1] == TRUE) {
				FCalculationAverage(Data_hydroPlate)
				Data_hydroPlateAv <- Res
				TEMPChecksums$Data_hydroPlateAv[1] <- sum(colSums(Data_hydroPlate))
				TEMPChecksums$Data_hydroPlateAv[2] <- sum(colSums(Data_hydroPlateAv))
				print("Data hydroPlate av")
				print(Data_hydroPlateAv[1:10,])
				## HydroPlate standarddeviation
				if (SETAnalysisOpt$SD == TRUE) {
					FCalculationStandarddev(Data_hydroPlate)
					Data_hydroPlateSd <- Res
					TEMPChecksums$Data_hydroPlateSd[1] <- sum(colSums(Data_hydroPlate))
					TEMPChecksums$Data_hydroPlateSd[2] <- sum(colSums(Data_hydroPlateSd))
					print("Data hydroPlate sd")
					print(Data_hydroPlateSd[1:10,])
				}
			}
			## medium average
			if (SETAnalysisOpt$medium[2] == TRUE & SETAnalysisOpt$medium[2] == TRUE) {
				FCalculationAverage(Data_medium)
				Data_mediumAv <- Res
				TEMPChecksums$Data_mediumAv[1] <- sum(colSums(Data_medium))
				TEMPChecksums$Data_mediumAv[2] <- sum(colSums(Data_mediumAv))
				print("Data normalisation av")
				print(Data_mediumAv[1:10,])
				## medium standarddeviation
				if (SETAnalysisOpt$SD == TRUE) {
					FCalculationStandarddev(Data_medium)
					Data_mediumSd <- Res
					TEMPChecksums$Data_mediumSd[1] <- sum(colSums(Data_medium))
					TEMPChecksums$Data_mediumSd[2] <- sum(colSums(Data_mediumSd))
					print("Data normalisation sd")
					print(Data_mediumSd[1:10,])
				}
			}
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

####
#### Signal: Rerun Smooth
#########################
gSignalConnect(btnSmoothRerun, "clicked", quote({
	if (FCheckBeforeAnalysis() == TRUE) {
		FStartAnalysis(rerun = TRUE)
		## raw smooth
		if (SETAnalysisOpt$smoothSelection[["Data_raw"]] == TRUE) {
			FCalculationSmooth(Data_raw)
			Data_rawSm <- ResSmooth
			TEMPChecksums$Data_rawSm[1] <- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSm[2] <- sum(colSums(Data_rawSm))
			print("Data raw smoothed")
		}
		## raw average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_rawAv"]] == TRUE) {
			FCalculationSmooth(Data_rawAv)
			Data_rawAvSm <- ResSmooth
			TEMPChecksums$Data_rawAvSm[1] <- sum(colSums(Data_rawAv))
			TEMPChecksums$Data_rawAvSm[2] <- sum(colSums(Data_rawAvSm))
			print("Data raw av smoothed")
			print(Data_rawAvSm[1:10,])
		}
		## OxoDish smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoDish"]] == TRUE) {
			FCalculationSmooth(Data_oxoDish)
			Data_oxoDishSm <- ResSmooth
			TEMPChecksums$Data_oxoDishSm[1] <- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSm[2] <- sum(colSums(Data_oxoDishSm))
			print("Data oxoDish smoothed")
			print(Data_oxoDishSm[1:10,])
		}
		## OxoDish average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoDishAv"]] == TRUE) {
			FCalculationSmooth(Data_oxoDishAv)
			Data_oxoDishAvSm <- ResSmooth
			TEMPChecksums$Data_oxoDishAvSm[1] <- sum(colSums(Data_oxoDishAv))
			TEMPChecksums$Data_oxoDishAvSm[2] <- sum(colSums(Data_oxoDishAvSm))
			print("Data oxoDish av smoothed")
			print(Data_oxoDishAvSm[1:10,])
		}
		## OxoPlate smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoPlate"]] == TRUE) {
			FCalculationSmooth(Data_oxoPlate)
			Data_oxoPlateSm <- ResSmooth
			TEMPChecksums$Data_oxoPlateSm[1] <- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSm[2] <- sum(colSums(Data_oxoPlateSm))
			print("Data oxoPlate smoothed")
			print(Data_oxoPlateSm[1:10,])
		}
		## OxoPlate average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoPlateAv"]] == TRUE) {
			FCalculationSmooth(Data_oxoPlateAv)
			Data_oxoPlateAvSm <- ResSmooth
			TEMPChecksums$Data_oxoPlateAvSm[1] <- sum(colSums(Data_oxoPlateAv))
			TEMPChecksums$Data_oxoPlateAvSm[2] <- sum(colSums(Data_oxoPlateAvSm))
			print("Data oxoPlate av smoothed")
			print(Data_oxoPlateAvSm[1:10,])
		}
		## HydroPlate smooth
		if (SETAnalysisOpt$smoothSelection[["Data_hydroPlate"]] == TRUE) {
			FCalculationSmooth(Data_hydroPlate)
			Data_hydroPlateSm <- ResSmooth
			TEMPChecksums$Data_hydroPlateSm[1] <- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSm[2] <- sum(colSums(Data_hydroPlateSm))
			print("Data hydroPlate smoothed")
			print(Data_hydroPlateSm[1:10,])
		}
		## HydroPlate average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_hydroPlateAv"]] == TRUE) {
			FCalculationSmooth(Data_hydroPlateAv)
			Data_hydroPlateAvSm <- ResSmooth
			TEMPChecksums$Data_hydroPlateAvSm[1] <- sum(colSums(Data_hydroPlateAv))
			TEMPChecksums$Data_hydroPlateAvSm[2] <- sum(colSums(Data_hydroPlateAvSm))
			print("Data hydroPlate av smoothed")
			print(Data_hydroPlateAvSm[1:10,])
		}
		## medium smooth
		if (SETAnalysisOpt$smoothSelection[["Data_medium"]] == TRUE) {
			FCalculationSmooth(Data_medium)
			Data_mediumSm <- ResSmooth
			TEMPChecksums$Data_mediumSm[1] <- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSm[2] <- sum(colSums(Data_mediumSm))
			print("Data normalisation smoothed")
			print(Data_mediumSm[1:10,])
		}
		## medium average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_mediumAv"]] == TRUE) {
			FCalculationSmooth(Data_mediumAv)
			Data_mediumAvSm <- ResSmooth
			TEMPChecksums$Data_mediumAvSm[1] <- sum(colSums(Data_mediumAv))
			TEMPChecksums$Data_mediumAvSm[2] <- sum(colSums(Data_mediumAvSm))
			print("Data normalisation av smoothed")
			print(Data_mediumAvSm[1:10,])
		}
		FEndAnalysis()
	}
}))

####
#### Signal: Rerun Slope
########################
gSignalConnect(btnSlopeRerun, "clicked", quote({
	if (FCheckBeforeAnalysis() == TRUE) {
		FStartAnalysis(rerun = TRUE)
## raw slope
		if (SETAnalysisOpt$slopeSelection[["Data_raw"]] == TRUE) {
			FCalculationSlope(Data_raw)
			Data_rawSlope <- ResSlope
			TEMPChecksums$Data_rawSlope[1] <- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSlope[2] <- sum(colSums(Data_rawSlope))
			Data_rawSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_rawSlopeSd[1] <- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSlopeSd[2] <- sum(colSums(Data_rawSlopeSd))
			print("Data raw slope")
			print(Data_rawSlope[1:10,])
			print("Data raw slope deviation")
			print(Data_rawSlopeSd[1:10,])
		}
## raw average slope
		if (SETAnalysisOpt$slopeSelection[["Data_rawAv"]] == TRUE) {
			FCalculationSlope(Data_rawAv)
			Data_rawAvSlope <- ResSlope
			TEMPChecksums$Data_rawAvSlope[1] <- sum(colSums(Data_rawAv))
			TEMPChecksums$Data_rawAvSlope[2] <- sum(colSums(Data_rawAvSlope))
			Data_rawAvSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_rawAvSlopeSd[1] <- sum(colSums(Data_rawAv))
			TEMPChecksums$Data_rawAvSlopeSd[2] <- sum(colSums(Data_rawAvSlopeSd))
			print("Data raw av slope")
			print(Data_rawAvSlope[1:10,])
			print("Data raw av slope deviation")
			print(Data_rawAvSlopeSd[1:10,])
		}
## OxoDish slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoDish"]] == TRUE) {
			FCalculationSlope(Data_oxoDish)
			Data_oxoDishSlope <- ResSlope
			TEMPChecksums$Data_oxoDishSlope[1] <- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSlope[2] <- sum(colSums(Data_oxoDishSlope))
			Data_oxoDishSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_oxoDishSlopeSd[1] <- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSlopeSd[2] <- sum(colSums(Data_oxoDishSlopeSd))
			print("Data oxoDish slope")
			print(Data_oxoDishSlope[1:10,])
			print("Data oxoDish slope deviation")
			print(Data_oxoDishSlopeSd[1:10,])
		}
## OxoDish average slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoDishAv"]] == TRUE) {
			FCalculationSlope(Data_oxoDishAv)
			Data_oxoDishAvSlope <- ResSlope
			TEMPChecksums$Data_oxoDishAvSlope[1] <- sum(colSums(Data_oxoDishAv))
			TEMPChecksums$Data_oxoDishAvSlope[2] <- sum(colSums(Data_oxoDishAvSlope))
			Data_oxoDishAvSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_oxoDishAvSlopeSd[1] <- sum(colSums(Data_oxoDishAv))
			TEMPChecksums$Data_oxoDishAvSlopeSd[2] <- sum(colSums(Data_oxoDishAvSlopeSd))
			print("Data oxoDish av slope")
			print(Data_oxoDishAvSlope[1:10,])
			print("Data oxoDish av slope deviation")
			print(Data_oxoDishAvSlopeSd[1:10,])
		}
## OxoPlate slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoPlate"]] == TRUE) {
			FCalculationSlope(Data_oxoPlate)
			Data_oxoPlateSlope <- ResSlope
			TEMPChecksums$Data_oxoPlateSlope[1] <- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSlope[2] <- sum(colSums(Data_oxoPlateSlope))
			Data_oxoPlateSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_oxoPlateSlopeSd[1] <- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSlopeSd[2] <- sum(colSums(Data_oxoPlateSlopeSd))
			print("Data oxoPlate slope")
			print(Data_oxoPlateSlope[1:10,])
			print("Data oxoPlate slope deviation")
			print(Data_oxoPlateSlopeSd[1:10,])
		}
## OxoPlate average slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoPlateAv"]] == TRUE) {
			FCalculationSlope(Data_oxoPlateAv)
			Data_oxoPlateAvSlope <- ResSlope
			TEMPChecksums$Data_oxoPlateAvSlope[1] <- sum(colSums(Data_oxoPlateAv))
			TEMPChecksums$Data_oxoPlateAvSlope[2] <- sum(colSums(Data_oxoPlateAvSlope))
			Data_oxoPlateAvSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_oxoPlateAvSlopeSd[1] <- sum(colSums(Data_oxoPlateAv))
			TEMPChecksums$Data_oxoPlateAvSlopeSd[2] <- sum(colSums(Data_oxoPlateAvSlopeSd))
			print("Data oxoPlate av slope")
			print(Data_oxoPlateAvSlope[1:10,])
			print("Data oxoPlate av slope deviation")
			print(Data_oxoPlateAvSlopeSd[1:10,])
		}
## HydroPlate slope
		if (SETAnalysisOpt$slopeSelection[["Data_hydroPlate"]] == TRUE) {
			FCalculationSlope(Data_hydroPlate)
			Data_hydroPlateSlope <- ResSlope
			TEMPChecksums$Data_hydroPlateSlope[1] <- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSlope[2] <- sum(colSums(Data_hydroPlateSlope))
			Data_hydroPlateSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_hydroPlateSlopeSd[1] <- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSlopeSd[2] <- sum(colSums(Data_hydroPlateSlopeSd))
			print("Data hydroPlate slope")
			print(Data_hydroPlateSlope[1:10,])
			print("Data hydroPlate slope deviation")
			print(Data_hydroPlateSlopeSd[1:10,])
		}
## HydroPlate average slope
		if (SETAnalysisOpt$slopeSelection[["Data_hydroPlateAv"]] == TRUE) {
			FCalculationSlope(Data_hydroPlateAv)
			Data_hydroPlateAvSlope <- ResSlope
			TEMPChecksums$Data_hydroPlateAvSlope[1] <- sum(colSums(Data_hydroPlateAv))
			TEMPChecksums$Data_hydroPlateAvSlope[2] <- sum(colSums(Data_hydroPlateAvSlope))
			Data_hydroPlateAvSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_hydroPlateAvSlopeSd[1] <- sum(colSums(Data_hydroPlateAv))
			TEMPChecksums$Data_hydroPlateAvSlopeSd[2] <- sum(colSums(Data_hydroPlateAvSlopeSd))
			print("Data hydroPlate av slope")
			print(Data_hydroPlateAvSlope[1:10,])
			print("Data hydroPlate av slope deviation")
			print(Data_hydroPlateAvSlopeSd[1:10,])
		}
## medium slope
		if (SETAnalysisOpt$slopeSelection[["Data_medium"]] == TRUE) {
			FCalculationSlope(Data_medium)
			Data_mediumSlope <- ResSlope
			TEMPChecksums$Data_mediumSlope[1] <- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSlope[2] <- sum(colSums(Data_mediumSlope))
			Data_mediumSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_mediumSlopeSd[1] <- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSlopeSd[2] <- sum(colSums(Data_mediumSlopeSd))
			print("Data normalisation slope")
			print(Data_mediumSlope[1:10,])
			print("Data normalisation slope deviation")
			print(Data_mediumSlopeSd[1:10,])
		}
## medium average slope
		if (SETAnalysisOpt$slopeSelection[["Data_mediumAv"]] == TRUE) {
			FCalculationSlope(Data_mediumAv)
			Data_mediumAvSlope <- ResSlope
			TEMPChecksums$Data_mediumAvSlope[1] <- sum(colSums(Data_mediumAv))
			TEMPChecksums$Data_mediumAvSlope[2] <- sum(colSums(Data_mediumAvSlope))
			Data_mediumAvSlopeSd <- ResSlopeSd
			TEMPChecksums$Data_mediumAvSlopeSd[1] <- sum(colSums(Data_mediumAv))
			TEMPChecksums$Data_mediumAvSlopeSd[2] <- sum(colSums(Data_mediumAvSlopeSd))
			print("Data normalisation av slope")
			print(Data_mediumAvSlope[1:10,])
			print("Data normalisation av slope deviation")
			print(Data_mediumAvSlopeSd[1:10,])
		}
		FEndAnalysis()
	}
}))

gSignalConnect(btnConsRerun, "clicked", quote({
	if (FCheckBeforeAnalysis() == TRUE) {
		FStartAnalysis(rerun = TRUE)
## raw cons
		if (SETAnalysisOpt$ConsSelection[["Data_raw"]] == TRUE) {
			FCalculationCons(Data_raw, Data_rawSlope)
			Data_rawCons <- ResCons
			TEMPChecksums$Data_rawCons[1] <- sum(colSums(Data_rawSlope))
			TEMPChecksums$Data_rawCons[2] <- sum(colSums(Data_rawCons))
			Data_rawConsSd <- ResConsSd
			TEMPChecksums$Data_rawConsSd[1] <- sum(colSums(Data_rawSlope))
			TEMPChecksums$Data_rawConsSd[2] <- sum(colSums(Data_rawConsSd))
			print("Data consumption from raw")
			print(Data_rawCons[1:10,])
			print("Data consumption from raw deviation")
			print(Data_rawConsSd[1:10,])
		}
## raw average cons
		if (SETAnalysisOpt$ConsSelection[["Data_rawAv"]] == TRUE) {
			FCalculationCons(Data_rawAv, Data_rawAvSlope, Data_rawSd)
			Data_rawAvCons <- ResCons
			TEMPChecksums$Data_rawAvCons[1] <- sum(colSums(Data_rawAvSlope))
			TEMPChecksums$Data_rawAvCons[2] <- sum(colSums(Data_rawAvCons))
			Data_rawAvConsSd <- ResConsSd
			TEMPChecksums$Data_rawAvConsSd[1] <- sum(colSums(Data_rawAvSlope))
			TEMPChecksums$Data_rawAvConsSd[2] <- sum(colSums(Data_rawAvConsSd))
			print("Data consumption from raw av")
			print(Data_rawAvCons[1:10,])
			print("Data consumption from raw av deviation")
			print(Data_rawAvConsSd[1:10,])
		}
## OxoDish cons
		if (SETAnalysisOpt$ConsSelection[["Data_oxoDish"]] == TRUE) {
			FCalculationSlope(Data_oxoDish, Data_oxoDishSlope)
			Data_oxoDishCons <- ResCons
			TEMPChecksums$Data_oxoDishCons[1] <- sum(colSums(Data_oxoDishSlope))
			TEMPChecksums$Data_oxoDishCons[2] <- sum(colSums(Data_oxoDishCons))
			Data_oxoDishConsSd <- ResConsSd
			TEMPChecksums$Data_oxoDishConsSd[1] <- sum(colSums(Data_oxoDishSlope))
			TEMPChecksums$Data_oxoDishConsSd[2] <- sum(colSums(Data_oxoDishConsSd))
			print("Data consumption from oxoDish")
			print(Data_oxoDishCons[1:10,])
			print("Data consumption from oxoDish deviation")
			print(Data_oxoDishConsSd[1:10,])
		}
## OxoDish average cons
		if (SETAnalysisOpt$ConsSelection[["Data_oxoDishAv"]] == TRUE) {
			FCalculationCons(Data_oxoDishAv, Data_oxoDishAvSlope, Data_oxoDishSd)
			Data_oxoDishAvCons <- ResCons
			TEMPChecksums$Data_oxoDishAvCons[1] <- sum(colSums(Data_oxoDishAvSlope))
			TEMPChecksums$Data_oxoDishAvCons[2] <- sum(colSums(Data_oxoDishAvCons))
			Data_oxoDishAvConsSd <- ResConsSd
			TEMPChecksums$Data_oxoDishAvConsSd[1] <- sum(colSums(Data_oxoDishAvSlope))
			TEMPChecksums$Data_oxoDishAvConsSd[2] <- sum(colSums(Data_oxoDishAvConsSd))
			print("Data consumption from av oxoDish")
			print(Data_oxoDishAvCons[1:10,])
			print("Data consumption from av oxoDish deviation")
			print(Data_oxoDishAvConsSd[1:10,])
		}
## OxoPlate cons
		if (SETAnalysisOpt$ConsSelection[["Data_oxoPlate"]] == TRUE) {
			FCalculationCons(Data_oxoPlate, Data_oxoPlateSlope)
			Data_oxoPlateCons <- ResCons
			TEMPChecksums$Data_oxoPlateCons[1] <- sum(colSums(Data_oxoPlateSlope))
			TEMPChecksums$Data_oxoPlateCons[2] <- sum(colSums(Data_oxoPlateCons))
			Data_oxoPlateConsSd <- ResConsSd
			TEMPChecksums$Data_oxoPlateConsSd[1] <- sum(colSums(Data_oxoPlateSlope))
			TEMPChecksums$Data_oxoPlateConsSd[2] <- sum(colSums(Data_oxoPlateConsSd))
			print("Data consumption from oxoPlate")
			print(Data_oxoPlateCons[1:10,])
			print("Data consumption from oxoPlate deviation")
			print(Data_oxoPlateConsSd[1:10,])
		}
## OxoPlate average cons
		if (SETAnalysisOpt$ConsSelection[["Data_oxoPlateAv"]] == TRUE) {
			FCalculationCons(Data_oxoPlateAv, Data_oxoPlateAvSlope, Data_oxoPlateSd)
			Data_oxoPlateAvCons <- ResCons
			TEMPChecksums$Data_oxoPlateAvCons[1] <- sum(colSums(Data_oxoPlateAvSlope))
			TEMPChecksums$Data_oxoPlateAvCons[2] <- sum(colSums(Data_oxoPlateAvCons))
			Data_oxoPlateAvConsSd <- ResConsSd
			TEMPChecksums$Data_oxoPlateAvConsSd[1] <- sum(colSums(Data_oxoPlateAvSlope))
			TEMPChecksums$Data_oxoPlateAvConsSd[2] <- sum(colSums(Data_oxoPlateAvConsSd))
			print("Data consumption from av oxoPlate")
			print(Data_oxoPlateAvCons[1:10,])
			print("Data consumption from av oxoPlate deviation")
			print(Data_oxoPlateAvConsSd[1:10,])
		}
## medium cons
		if (SETAnalysisOpt$ConsSelection[["Data_medium"]] == TRUE) {
			FCalculationCons(Data_medium, Data_mediumSlope)
			Data_mediumCons <- ResCons
			TEMPChecksums$Data_mediumCons[1] <- sum(colSums(Data_mediumSlope))
			TEMPChecksums$Data_mediumCons[2] <- sum(colSums(Data_mediumCons))
			Data_mediumConsSd <- ResConsSd
			TEMPChecksums$Data_mediumConsSd[1] <- sum(colSums(Data_mediumSlope))
			TEMPChecksums$Data_mediumConsSd[2] <- sum(colSums(Data_mediumConsSd))
			print("Data consumption from normalisation")
			print(Data_mediumCons[1:10,])
			print("Data consumption from medium normalisation")
			print(Data_mediumConsSd[1:10,])
		}
## medium average cons
		if (SETAnalysisOpt$ConsSelection[["Data_mediumAv"]] == TRUE) {
			FCalculationCons(Data_mediumAv, Data_mediumAvSlope, Data_mediumSd)
			Data_mediumAvCons <- ResCons
			TEMPChecksums$Data_mediumAvCons[1] <- sum(colSums(Data_mediumAvSlope))
			TEMPChecksums$Data_mediumAvCons[2] <- sum(colSums(Data_mediumAvCons))
			Data_mediumAvConsSd <- ResConsSd
			TEMPChecksums$Data_mediumAvConsSd[1] <- sum(colSums(Data_mediumAvSlope))
			TEMPChecksums$Data_mediumAvConsSd[2] <- sum(colSums(Data_mediumAvConsSd))
			print("Data consumption from av normalisation")
			print(Data_mediumAvCons[1:10,])
			print("Data consumption from av medium normalisation")
			print(Data_mediumAvConsSd[1:10,])
		}
		FEndAnalysis()
	}
}))

gSignalConnect(btnIC50Rerun, "clicked", quote({
	if (FCheckBeforeAnalysis() == TRUE) {
		FStartAnalysis(rerun = TRUE)
		FCalculationIC50()
		TEMPChecksums$Data_IC50[1] <- sum(colSums(get(SETAnalysisOpt$IC50)))
		TEMPChecksums$Data_IC50[2] <- sum(colSums(Data_IC50))
		print("IC50 data")
		print(Data_IC50[1:10,])
		TEMPChecksums$Data_IC50Models[1] <- sum(colSums(get(SETAnalysisOpt$IC50)))
		TEMPChecksums$Data_IC50Models[2] <- sum(as.numeric(names(Data_IC50Models)))
		print("IC50 fitting data")
		print(Data_IC50Models[1:3])
		FEndAnalysis()
	}
}))

#########################################################################################
#### Run Analysis execute
#########################################################################################

####
#### Function: Check Input before running Analysis
##################################################
FCheckBeforeAnalysis <- function() {
	proceed <- 1
	
	## Check on Data Import
	if (Data_input[1,1] == "empty") {
		POPFinalDataimport <- gtkMessageDialog(mainApplication, "destroy-with-parent", "error", "ok", "Please import data first!")
		if (POPFinalDataimport$run() == GtkResponseType["ok"]) POPFinalDataimport$destroy()
		proceed <- 0
	
	## Check on Template Import
	} else if (Template[1,1] == "empty") {
		POPFinalTemplate <- gtkMessageDialog(mainApplication, "destroy-with-parent", "error", "ok", "Please enter all labels and colours first!")
		if (POPFinalTemplate$run() == GtkResponseType["ok"]) POPFinalTemplate$destroy()
		proceed <- 0
	
	## Check on all input again
	} else {
		FCheckDataInput(CheckInputDataInput)
		FFileInputCollect()
		FCheckLabelColour(CheckInputLabelColour)
		FCheckGraphOpt(CheckInputGraphOpt)
		FCheckAnalysisOpt(CheckInputAnalysisOpt)
		FCheckDataOutput(CheckInputDataOutput)
		
		errormessages <- BXErrormessages$getChildren()
		for (i in 1:length(errormessages)) {
			if (errormessages[[i]]["visible"] == TRUE) { #if any of the errormessages is visible produce popup
				proceed <- 0
				POPFinalError <- gtkMessageDialog(mainApplication, "destroy-with-parent", "error", "ok", "Please solve all status messages and try again!")
				if (POPFinalError$run() == "ok") POPFinalError$destroy()
				else POPFinalError$destroy()
				break
			}
		}
		
		if (proceed == 1) {
			if (FCheckDataImported(Data_input) == FALSE) proceed <- 0
			if (FCheckTemplateLoaded(Template) == FALSE) proceed <- 0
		}
	}
	
	return(as.logical(proceed))
}

####
#### Function: Get Project Name
###############################
FFinalProjectname <- function() {
	POPFinalProjectname <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", buttons = "none", "Please enter the name of the results folder to be created.", show = TRUE)
	POPFinalProjectname$addButton("Continue", 1)
	POPFinalProjectname$addButton("Cancel", 2)
	ENTProjectname <- gtkEntry()
	ENTProjectname$setText(SETDataOutput$folder)
	ENTProjectname$setSizeRequest(-1, 20)
	ERRFolder <- gtkLabel("Please enter a name for the folder.")
	ERRFolder["visible"] <- FALSE
	LBLFolder <- gtkLabel("If you want to enter a path the upper directories have to exist already.")
	POPFinalProjectname[["vbox"]]$add(LBLFolder)
	POPFinalProjectname[["vbox"]]$add(ERRFolder)
	POPFinalProjectname[["vbox"]]$add(ENTProjectname)
	initiation <- 1
	while (initiation == 1) {
		response <- POPFinalProjectname$run()[1]
		if (response == 1) {
			text <- ENTProjectname$getText()
			if (text != "foldername") {
				ERRFolder["visible"] <- FALSE
				SETDataOutput$folder <<- text
				dir.create(text)
				initiation <- 0
				proceed <- 1
				POPFinalProjectname$destroy()
			} else {
				ERRFolder["visible"] <- TRUE
				initiation <- 1
			}
		} else {
			proceed <- 0
			initiation <- 0
			POPFinalProjectname$destroy()
		}
	}
	return(as.logical(proceed))
}

####
#### Function: Start Analysis
#############################
FStartAnalysis <- function(rerun) {
	POPAnalysisRunning <<- gtkMessageDialog(mainApplication, "destroy-with-parent", "status", buttons = "none", "Analysis running. This can take some time.\n")
	LBLAnalysisRunning <- gtkLabel("Your settings were saved automatically to the results folder.")
	POPAnalysisRunning[["vbox"]]$add(LBLAnalysisRunning)
	Sys.sleep(.1)
	SETGraphOutput <<- list(Scalebar = SETGraphOutput$Scalebar, IC50 = SETGraphOutput$IC50)
	FSaveSettings(paste(SETDataOutput$folder, "autosave_settings.txt", sep="/"))
	if (rerun == FALSE) source("Program/Analyser_4.R")
	TSStartAnalysis <<- Sys.time()
}

####
#### Function: End analysis
###########################
FEndAnalysis <- function() {
	TSEndAnalysis <<- Sys.time()
	gSignalEmit(btnGraphs, "clicked")
	gSignalEmit(btnRawShow, "clicked")
	if (class(POPAnalysisRunning)[1] == "GtkMessageDialog") {
		POPAnalysisRunning["text"] <- paste(POPAnalysisRunning["text"], "\n\nThe analysis is finished and took", as.double(difftime(TSEndAnalysis, TSStartAnalysis, units=c("secs"))), "seconds.", sep=" ")
		POPAnalysisRunning$addButton("Close", 1)
		if (POPAnalysisRunning$run() == 1) POPAnalysisRunning$destroy()
		else POPAnalysisRunning$destroy()
	} else {
		POPAnalysisRunning <- gtkMessageDialog(mainApplication, "destroy-with-parent", "status", buttons = "none", "Analysis finished.")
		POPAnalysisRunning$addButton("Close", 1)
		if (POPAnalysisRunning$run() == 1) POPAnalysisRunning$destroy()
		else POPAnalysisRunning$destroy()
	}
}

####
#### Function: Run Analysis
###########################
FRunAnalysis <- function(rerun) {
	
	FShowRerunButtons()
	
	if (SETBorders$header == TRUE & SETBorders$remove == FALSE & rerun == FALSE) {
		output <- file(paste(getwd(), SETDataOutput$folder, "Header_exported.csv", sep="/"), open ="w")
		write.table(Header, file = output, sep = SETDataOutput$separator, dec = SETDataOutput$decimal, col.names = TRUE, row.names = FALSE)
		close(output)
	}
	
	## Prepare data sets, reduce Input data set and Template according to exclude in Template
	if (rerun == FALSE) {
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\nEmptying data sets")
		Data_raw <<- data.frame()
		Data_rawOrig <<- data.frame()
		Data_rawSm <<- data.frame()
		Data_rawSlope <<- data.frame()
		Data_rawSlopeSd <<- data.frame()
		Data_rawCons <<- data.frame()
		Data_rawConsSd <<- data.frame()
		Data_rawAv <<- data.frame()
		Data_rawAvSm <<- data.frame()
		Data_rawAvSlope <<- data.frame()
		Data_rawAvSlopeSd <<- data.frame()
		Data_rawAvCons <<- data.frame()
		Data_rawAvConsSd <<- data.frame()
		Data_rawSd <<- data.frame()
		Data_oxoDish <<- data.frame()
		Data_oxoDishOrig <<- data.frame()
		Data_oxoDishSm <<- data.frame()
		Data_oxoDishSlope <<- data.frame()
		Data_oxoDishSlopeSd <<- data.frame()
		Data_oxoDishCons <<- data.frame()
		Data_oxoDishConsSd <<- data.frame()
		Data_oxoDishAv <<- data.frame()
		Data_oxoDishAvSm <<- data.frame()
		Data_oxoDishAvSlope <<- data.frame()
		Data_oxoDishAvSlopeSd <<- data.frame()
		Data_oxoDishAvCons <<- data.frame()
		Data_oxoDishAvConsSd <<- data.frame()
		Data_oxoDishSd <<- data.frame()
		Data_oxoPlate <<- data.frame()
		Data_oxoPlateOrig <<- data.frame()
		Data_oxoPlateSm <<- data.frame()
		Data_oxoPlateSlope <<- data.frame()
		Data_oxoPlateSlopeSd <<- data.frame()
		Data_oxoPlateCons <<- data.frame()
		Data_oxoPlateConsSd <<- data.frame()
		Data_oxoPlateAv <<- data.frame()
		Data_oxoPlateAvSm <<- data.frame()
		Data_oxoPlateAvSlope <<- data.frame()
		Data_oxoPlateAvSlopeSd <<- data.frame()
		Data_oxoPlateAvCons <<- data.frame()
		Data_oxoPlateAvConsSd <<- data.frame()
		Data_oxoPlateSd <<- data.frame()
		Data_hydroPlate <<- data.frame()
		Data_hydroPlateOrig <<- data.frame()
		Data_hydroPlateCal <<- data.frame()
		Data_hydroPlateSm <<- data.frame()
		Data_hydroPlateSlope <<- data.frame()
		Data_hydroPlateSlopeSd <<- data.frame()
		Data_hydroPlateAv <<- data.frame()
		Data_hydroPlateAvSm <<- data.frame()
		Data_hydroPlateAvSlope <<- data.frame()
		Data_hydroPlateAvSlopeSd <<- data.frame()
		Data_hydroPlateSd <<- data.frame()
		Data_medium <<- data.frame()
		Data_mediumOrig <<- data.frame()
		Data_mediumSm <<- data.frame()
		Data_mediumSlope <<- data.frame()
		Data_mediumSlopeSd <<- data.frame()
		Data_mediumCons <<- data.frame()
		Data_mediumConsSd <<- data.frame()
		Data_mediumAv <<- data.frame()
		Data_mediumAvSm <<- data.frame()
		Data_mediumAvSlope <<- data.frame()
		Data_mediumAvSlopeSd <<- data.frame()
		Data_mediumAvCons <<- data.frame()
		Data_mediumAvConsSd <<- data.frame()
		Data_mediumSd <<- data.frame()
		Data_IC50 <<- data.frame()
		Data_IC50Models <<- list()
		TemplateAverage <<- data.frame("empty" = "empty")
		TEMPChecksums <<- list(	Data_input = "imported",
							Data_raw = c("used", "resulting"),
							Data_rawOrig = c("used", "resulting"),
							Data_rawSm = c("used", "resulting"),
							Data_rawSlope = c("used", "resulting"),
							Data_rawSlopeSd = c("used", "resulting"),
							Data_rawCons = c("used", "resulting"),
							Data_rawConsSd = c("used", "resulting"),
							Data_rawAv = c("used", "resulting"),
							Data_rawAvSm = c("used", "resulting"),
							Data_rawAvSlope = c("used", "resulting"),
							Data_rawAvSlopeSd = c("used", "resulting"),
							Data_rawAvCons = c("used", "resulting"),
							Data_rawAvConsSd = c("used", "resulting"),
							Data_rawSd = c("used", "resulting"),
							Data_oxoDish = c("used", "resulting"),
							Data_oxoDishOrig = c("used", "resulting"),
							Data_oxoDishSm = c("used", "resulting"),
							Data_oxoDishSlope = c("used", "resulting"),
							Data_oxoDishSlopeSd = c("used", "resulting"),
							Data_oxoDishCons = c("used", "resulting"),
							Data_oxoDishConsSd = c("used", "resulting"),
							Data_oxoDishAv = c("used", "resulting"),
							Data_oxoDishAvSm = c("used", "resulting"),
							Data_oxoDishAvSlope = c("used", "resulting"),
							Data_oxoDishAvSlopeSd = c("used", "resulting"),
							Data_oxoDishAvCons = c("used", "resulting"),
							Data_oxoDishAvConsSd = c("used", "resulting"),
							Data_oxoDishSd = c("used", "resulting"),
							Data_oxoPlate = c("used", "resulting"),
							Data_oxoPlateOrig = c("used", "resulting"),
							Data_oxoPlateSm = c("used", "resulting"),
							Data_oxoPlateSlope = c("used", "resulting"),
							Data_oxoPlateSlopeSd = c("used", "resulting"),
							Data_oxoPlateCons = c("used", "resulting"),
							Data_oxoPlateConsSd = c("used", "resulting"),
							Data_oxoPlateAv = c("used", "resulting"),
							Data_oxoPlateAvSm = c("used", "resulting"),
							Data_oxoPlateAvSlope = c("used", "resulting"),
							Data_oxoPlateAvSlopeSd = c("used", "resulting"),
							Data_oxoPlateAvCons = c("used", "resulting"),
							Data_oxoPlateAvConsSd = c("used", "resulting"),
							Data_oxoPlateSd = c("used", "resulting"),
							Data_hydroPlate = c("used", "resulting"),
							Data_hydroPlateOrig = c("used", "resulting"),
							Data_hydroPlateCal = c("used", "resulting"),
							Data_hydroPlateSm = c("used", "resulting"),
							Data_hydroPlateSlope = c("used", "resulting"),
							Data_hydroPlateSlopeSd = c("used", "resulting"),
							Data_hydroPlateAv = c("used", "resulting"),
							Data_hydroPlateAvSm = c("used", "resulting"),
							Data_hydroPlateAvSlope = c("used", "resulting"),
							Data_hydroPlateAvSlopeSd = c("used", "resulting"),
							Data_hydroPlateSd = c("used", "resulting"),
							Data_medium = c("used", "resulting"),
							Data_mediumOrig = c("used", "resulting"),
							Data_mediumSm = c("used", "resulting"),
							Data_mediumSlope = c("used", "resulting"),
							Data_mediumSlopeSd = c("used", "resulting"),
							Data_mediumCons = c("used", "resulting"),
							Data_mediumConsSd = c("used", "resulting"),
							Data_mediumAv = c("used", "resulting"),
							Data_mediumAvSm = c("used", "resulting"),
							Data_mediumAvSlope = c("used", "resulting"),
							Data_mediumAvSlopeSd = c("used", "resulting"),
							Data_mediumAvCons = c("used", "resulting"),
							Data_mediumAvConsSd = c("used", "resulting"),
							Data_mediumSd = c("used", "resulting"),
							Data_IC50 = c("used", "resulting"),
							Data_IC50Models = c("used", "resulting") )
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done\n\nCalculating raw data")
		FCalculationRaw(Data_input)
		TEMPChecksums$Data_input <<- sum(colSums(Data_input))
		TEMPChecksums$Data_raw[1] <<- sum(colSums(Data_input))
		TEMPChecksums$Data_raw[2] <<- sum(colSums(Data_raw))
		FTemplateMean()
		print("Data raw")
		print(Data_raw[1:10,])
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
	}
	
	if (length(Data_rawOrig[1,1]) != 0) Data_raw <<- Data_rawOrig
	if (length(SETAnalysisOpt$Formatting) != 0) {
		## raw formatting
		if (SETAnalysisOpt$Formatting == "Data_raw") {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
			if (length(Data_rawOrig[1,1]) == 0)  {
				Data_rawOrig <<- Data_raw
				TEMPChecksums$Data_rawOrig[1] <<- sum(colSums(Data_input))
				TEMPChecksums$Data_rawOrig[2] <<- sum(colSums(Data_rawOrig))
			}
			FCalculationFormatting(Data_raw)
			Data_raw <<- ResFormat
			TEMPChecksums$Data_raw[2] <<- sum(colSums(Data_raw))
			print("Data raw formatted")
			print(Data_raw[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	## raw smooth
	if (SETAnalysisOpt$smoothSelection[["Data_raw"]] == TRUE & TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_rawSm[1]) {
		## only run if smooth is not the same as smooth for slope calculation
		if (SETAnalysisOpt$slopeSelection[["Data_raw"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
			FCalculationSmooth(Data_raw)
			Data_rawSm <<- ResSmooth
			TEMPChecksums$Data_rawSm[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSm[2] <<- sum(colSums(Data_rawSm))
			print("Data raw smoothed")
			print(Data_rawSm[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		} else {
			rawSmoothReplace <- TRUE
		}
	}
	## raw slope
	if (SETAnalysisOpt$slopeSelection[["Data_raw"]] == TRUE & TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_rawSlope[1]) {
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
		FCalculationSlope(Data_raw)
		if (exists("rawSmoothReplace") == TRUE) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
			Data_rawSm <<- ResSmooth
			TEMPChecksums$Data_rawSm[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSm[2] <<- sum(colSums(Data_rawSm))
			print("Data raw smoothed")
			print(Data_rawSm[1:10,])
			## remove variable to prevent rerun complication
			rm(rawSmoothReplace)
		}
		Data_rawSlope <<- ResSlope
		TEMPChecksums$Data_rawSlope[1] <<- sum(colSums(Data_raw))
		TEMPChecksums$Data_rawSlope[2] <<- sum(colSums(Data_rawSlope))
		Data_rawSlopeSd <<- ResSlopeSd
		TEMPChecksums$Data_rawSlopeSd[1] <<- sum(colSums(Data_raw))
		TEMPChecksums$Data_rawSlopeSd[2] <<- sum(colSums(Data_rawSlopeSd))
		print("Data raw slope")
		print(Data_rawSlope[1:10,])
		print("Data raw slope deviation")
		print(Data_rawSlopeSd[1:10,])
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
	}
	## raw consumption
	if (SETAnalysisOpt$ConsSelection["Data_raw"] == TRUE & TEMPChecksums$Data_rawSlope[2] != TEMPChecksums$Data_rawCons[1]) {
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
		FCalculationCons(Data_raw, Data_rawSlope)
		Data_rawCons <<- ResCons
		TEMPChecksums$Data_rawCons[1] <<- sum(colSums(Data_rawSlope))
		TEMPChecksums$Data_rawCons[2] <<- sum(colSums(Data_rawCons))
		Data_rawConsSd <<- ResConsSd
		TEMPChecksums$Data_rawConsSd[1] <<- sum(colSums(Data_rawSlope))
		TEMPChecksums$Data_rawConsSd[2] <<- sum(colSums(Data_rawConsSd))
		print("Data consumption from raw")
		print(Data_rawCons[1:10,])
		print("Data consumption from raw deviation")
		print(Data_rawConsSd[1:10,])
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
	}
	## raw average
	if (SETAnalysisOpt$raw[2] == TRUE) {
		if (TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_rawAv[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating average raw data")
			FCalculationAverage(Data_raw)
			Data_rawAv <<- Res
			TEMPChecksums$Data_rawAv[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawAv[2] <<- sum(colSums(Data_rawAv))
			print("Data raw av")
			print(Data_rawAv[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## raw standarddeviation
		if (SETAnalysisOpt$SD == TRUE & TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_rawSd[1]) {
			FCalculationStandarddev(Data_raw)
			Data_rawSd <<- Res
			TEMPChecksums$Data_rawSd[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_rawSd[2] <<- sum(colSums(Data_rawSd))
			print("Data raw sd")
			print(Data_rawSd[1:10,])
		}
		## raw average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_rawAv"]] == TRUE & TEMPChecksums$Data_rawAv[2] != TEMPChecksums$Data_rawAvSm[1]) {
			## only run if smooth is not the same as smooth for slope calculation
			if (SETAnalysisOpt$slopeSelection[["Data_rawAv"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_rawAv)
				Data_rawAvSm <<- ResSmooth
				TEMPChecksums$Data_rawAvSm[1] <<- sum(colSums(Data_rawAv))
				TEMPChecksums$Data_rawAvSm[2] <<- sum(colSums(Data_rawAvSm))
				print("Data raw av smoothed")
				print(Data_rawAvSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				rawAvSmoothReplace <- TRUE
			}
		}
		## raw average slope
		if (SETAnalysisOpt$slopeSelection[["Data_rawAv"]] == TRUE & TEMPChecksums$Data_rawAv[2] != TEMPChecksums$Data_rawAvSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_rawAv)
			if (exists("rawAvSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_rawAvSm <<- ResSmooth
				TEMPChecksums$Data_rawAvSm[1] <<- sum(colSums(Data_rawAv))
				TEMPChecksums$Data_rawAvSm[2] <<- sum(colSums(Data_rawAvSm))
				print("Data raw av smoothed")
				print(Data_rawAvSm[1:10,])
				## remove variable to prevent rerun complication
				rm(rawAvSmoothReplace)
			}
			Data_rawAvSlope <<- ResSlope
			TEMPChecksums$Data_rawAvSlope[1] <<- sum(colSums(Data_rawAv))
			TEMPChecksums$Data_rawAvSlope[2] <<- sum(colSums(Data_rawAvSlope))
			Data_rawAvSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_rawAvSlopeSd[1] <<- sum(colSums(Data_rawAv))
			TEMPChecksums$Data_rawAvSlopeSd[2] <<- sum(colSums(Data_rawAvSlopeSd))
			print("Data raw av slope")
			print(Data_rawAvSlope[1:10,])
			print("Data raw av slope deviation")
			print(Data_rawAvSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## raw average consumption
		if (SETAnalysisOpt$ConsSelection["Data_rawAv"] == TRUE & TEMPChecksums$Data_rawAvSlope[2] != TEMPChecksums$Data_rawAvCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_rawAv, Data_rawAvSlope, Data_rawSd)
			Data_rawAvCons <<- ResCons
			TEMPChecksums$Data_rawAvCons[1] <<- sum(colSums(Data_rawAvSlope))
			TEMPChecksums$Data_rawAvCons[2] <<- sum(colSums(Data_rawAvCons))
			Data_rawAvConsSd <<- ResConsSd
			TEMPChecksums$Data_rawAvConsSd[1] <<- sum(colSums(Data_rawAvSlope))
			TEMPChecksums$Data_rawAvConsSd[2] <<- sum(colSums(Data_rawAvConsSd))
			print("Data consumption from raw av")
			print(Data_rawAvCons[1:10,])
			print("Data consumption from raw av deviation")
			print(Data_rawAvConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	
	## OxoDish correction
	if (SETAnalysisOpt$oxoDish[1] == TRUE) {
		if (TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_oxoDish[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCorrecting OxoDish sensors")
			FCalculationOxoDish(Data_raw)
			TEMPChecksums$Data_oxoDish[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_oxoDish[2] <<- sum(colSums(Data_oxoDish))
			print("Data oxoDish")
			print(Data_oxoDish[1:10,])
			Data_oxoDishOrig <<- data.frame()
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		if (length(Data_oxoDishOrig[1,1]) != 0) Data_oxoDish <<- Data_oxoDishOrig
		if (length(SETAnalysisOpt$Formatting) != 0) {
			## OxoDish formatting
			if (SETAnalysisOpt$Formatting == "Data_oxoDish") {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
				if (length(Data_oxoDishOrig[1,1]) == 0)  {
					Data_oxoDishOrig <<- Data_oxoDish
					TEMPChecksums$Data_oxoDishOrig[1] <<- sum(colSums(Data_raw))
					TEMPChecksums$Data_oxoDishOrig[2] <<- sum(colSums(Data_oxoDishOrig))
				}
				FCalculationFormatting(Data_oxoDish)
				Data_oxoDish <<- ResFormat
				TEMPChecksums$Data_oxoDish[2] <<- sum(colSums(Data_oxoDish))
				print("Data oxoDish formatted")
				print(Data_oxoDish[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			}
		}
		## OxoDish smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoDish"]] == TRUE & TEMPChecksums$Data_oxoDish[2] != TEMPChecksums$Data_oxoDishSm[1]) {
			## only run if smooth is not the same as smooth for slope calculation
			if (SETAnalysisOpt$slopeSelection[["Data_oxoDish"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_oxoDish)
				Data_oxoDishSm <<- ResSmooth
				TEMPChecksums$Data_oxoDishSm[1] <<- sum(colSums(Data_oxoDish))
				TEMPChecksums$Data_oxoDishSm[2] <<- sum(colSums(Data_oxoDishSm))
				print("Data oxoDish smoothed")
				print(Data_oxoDishSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				oxoDishSmoothReplace <- TRUE
			}
		}
		## OxoDish slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoDish"]] == TRUE & TEMPChecksums$Data_oxoDish[2] != TEMPChecksums$Data_oxoDishSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_oxoDish)
			if (exists("oxoDishSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_oxoDishSm <<- ResSmooth
				TEMPChecksums$Data_oxoDishSm[1] <<- sum(colSums(Data_oxoDish))
				TEMPChecksums$Data_oxoDishSm[2] <<- sum(colSums(Data_oxoDishSm))
				print("Data oxoDish smoothed")
				print(Data_oxoDishSm[1:10,])
				## remove variable to prevent rerun complication
				rm(oxoDishSmoothReplace)
			}
			Data_oxoDishSlope <<- ResSlope
			TEMPChecksums$Data_oxoDishSlope[1] <<- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSlope[2] <<- sum(colSums(Data_oxoDishSlope))
			Data_oxoDishSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_oxoDishSlopeSd[1] <<- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSlopeSd[2] <<- sum(colSums(Data_oxoDishSlopeSd))
			print("Data oxoDish slope")
			print(Data_oxoDishSlope[1:10,])
			print("Data oxoDish slope deviation")
			print(Data_oxoDishSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoDish consumption
		if (SETAnalysisOpt$ConsSelection["Data_oxoDish"] == TRUE & TEMPChecksums$Data_oxoDishSlope[2] != TEMPChecksums$Data_oxoDishCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_oxoDish, Data_oxoDishSlope)
			Data_oxoDishCons <<- ResCons
			TEMPChecksums$Data_oxoDishCons[1] <<- sum(colSums(Data_oxoDishSlope))
			TEMPChecksums$Data_oxoDishCons[2] <<- sum(colSums(Data_oxoDishCons))
			Data_oxoDishConsSd <<- ResConsSd
			TEMPChecksums$Data_oxoDishConsSd[1] <<- sum(colSums(Data_oxoDishSlope))
			TEMPChecksums$Data_oxoDishConsSd[2] <<- sum(colSums(Data_oxoDishConsSd))
			print("Data consumption from oxoDish")
			print(Data_oxoDishCons[1:10,])
			print("Data consumption from oxoDish deviation")
			print(Data_oxoDishConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	## OxoDish average
	if (SETAnalysisOpt$oxoDish[2] == TRUE & SETAnalysisOpt$oxoDish[1] == TRUE) {
		if (TEMPChecksums$Data_oxoDish[2] != TEMPChecksums$Data_oxoDishAv[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating average corrected data")
			FCalculationAverage(Data_oxoDish)
			Data_oxoDishAv <<- Res
			TEMPChecksums$Data_oxoDishAv[1] <<- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishAv[2] <<- sum(colSums(Data_oxoDishAv))
			print("Data oxoDish av")
			print(Data_oxoDishAv[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoDish standarddeviation
		if (SETAnalysisOpt$SD == TRUE & TEMPChecksums$Data_oxoDish[2] != TEMPChecksums$Data_oxoDishSd[1]) {
			FCalculationStandarddev(Data_oxoDish)
			Data_oxoDishSd <<- Res
			TEMPChecksums$Data_oxoDishSd[1] <<- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_oxoDishSd[2] <<- sum(colSums(Data_oxoDishSd))
			print("Data oxoDish sd")
			print(Data_oxoDishSd[1:10,])
		}
		## OxoDish average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoDishAv"]] == TRUE & TEMPChecksums$Data_oxoDishAv[2] != TEMPChecksums$Data_oxoDishAvSm[1]) {
			## only run if smooth is not the same as smooth for slope calculation
			if (SETAnalysisOpt$slopeSelection[["Data_oxoDishAv"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_oxoDishAv)
				Data_oxoDishAvSm <<- ResSmooth
				TEMPChecksums$Data_oxoDishAvSm[1] <<- sum(colSums(Data_oxoDishAv))
				TEMPChecksums$Data_oxoDishAvSm[2] <<- sum(colSums(Data_oxoDishAvSm))
				print("Data oxoDish av smoothed")
				print(Data_oxoDishAvSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				oxoDishAvSmoothReplace <- TRUE
			}
		}
		## OxoDish average slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoDishAv"]] == TRUE & TEMPChecksums$Data_oxoDishAv[2] != TEMPChecksums$Data_oxoDishAvSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_oxoDishAv)
			if (exists("oxoDishAvSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_oxoDishAvSm <<- ResSmooth
				TEMPChecksums$Data_oxoDishAvSm[1] <<- sum(colSums(Data_oxoDishAv))
				TEMPChecksums$Data_oxoDishAvSm[2] <<- sum(colSums(Data_oxoDishAvSm))
				print("Data oxoDish av smoothed")
				print(Data_oxoDishAvSm[1:10,])
				## remove variable to prevent rerun complication
				rm(oxoDishAvSmoothReplace)
			}
			Data_oxoDishAvSlope <<- ResSlope
			TEMPChecksums$Data_oxoDishAvSlope[1] <<- sum(colSums(Data_oxoDishAv))
			TEMPChecksums$Data_oxoDishAvSlope[2] <<- sum(colSums(Data_oxoDishAvSlope))
			Data_oxoDishAvSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_oxoDishAvSlopeSd[1] <<- sum(colSums(Data_oxoDishAv))
			TEMPChecksums$Data_oxoDishAvSlopeSd[2] <<- sum(colSums(Data_oxoDishAvSlopeSd))
			print("Data oxoDish av slope")
			print(Data_oxoDishAvSlope[1:10,])
			print("Data oxoDish av slope deviation")
			print(Data_oxoDishAvSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoDish average consumption
		if (SETAnalysisOpt$ConsSelection["Data_oxoDishAv"] == TRUE & TEMPChecksums$Data_oxoDishAvSlope[2] != TEMPChecksums$Data_oxoDishAvCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_oxoDishAv, Data_oxoDishAvSlope, Data_oxoDishSd)
			Data_oxoDishAvCons <<- ResCons
			TEMPChecksums$Data_oxoDishAvCons[1] <<- sum(colSums(Data_oxoDishAvSlope))
			TEMPChecksums$Data_oxoDishAvCons[2] <<- sum(colSums(Data_oxoDishAvCons))
			Data_oxoDishAvConsSd <<- ResConsSd
			TEMPChecksums$Data_oxoDishAvConsSd[1] <<- sum(colSums(Data_oxoDishAvSlope))
			TEMPChecksums$Data_oxoDishAvConsSd[2] <<- sum(colSums(Data_oxoDishAvConsSd))
			print("Data consumption from oxoDish av")
			print(Data_oxoDishAvCons[1:10,])
			print("Data consumption from oxoDish av deviation")
			print(Data_oxoDishAvConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	
	## OxoPlate conversion
	if (SETAnalysisOpt$oxoPlate[1] == TRUE) {
		if (TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_oxoPlate[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalibrating OxoPlate data")
			FCalculationOxoPlate(Data_raw)
			TEMPChecksums$Data_oxoPlate[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_oxoPlate[2] <<- sum(colSums(Data_oxoPlate))
			print("Data oxoPlate")
			print(Data_oxoPlate[1:10,])
			Data_oxoPlateOrig <<- data.frame()
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		if (length(Data_oxoPlateOrig[1,1]) != 0) Data_oxoPlate <<- Data_oxoPlateOrig
		if (length(SETAnalysisOpt$Formatting) != 0) {
			## oxoPlate formatting
			if (SETAnalysisOpt$Formatting == "Data_oxoPlate") {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
				if (length(Data_oxoPlateOrig[1,1]) == 0) {
					Data_oxoPlateOrig <<- Data_oxoPlate
					TEMPChecksums$Data_oxoPlateOrig[1] <<- sum(colSums(Data_raw))
					TEMPChecksums$Data_oxoPlateOrig[2] <<- sum(colSums(Data_oxoPlateOrig))
				}
				FCalculationFormatting(Data_oxoPlate)
				Data_oxoPlate <<- ResFormat
				TEMPChecksums$Data_oxoPlate[2] <<- sum(colSums(Data_oxoPlate))
				print("Data oxoPlate formatted")
				print(Data_oxoPlate[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			}
		}
		## OxoPlate smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoPlate"]] == TRUE & TEMPChecksums$Data_oxoPlate[2] != TEMPChecksums$Data_oxoPlateSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_oxoPlate"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_oxoPlate)
				Data_oxoPlateSm <<- ResSmooth
				TEMPChecksums$Data_oxoPlateSm[1] <<- sum(colSums(Data_oxoPlate))
				TEMPChecksums$Data_oxoPlateSm[2] <<- sum(colSums(Data_oxoPlateSm))
				print("Data oxoPlate smoothed")
				print(Data_oxoPlateSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				oxoPlateSmoothReplace <- TRUE
			}
		}
		## OxoPlate slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoPlate"]] == TRUE & TEMPChecksums$Data_oxoPlate[2] != TEMPChecksums$Data_oxoPlateSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_oxoPlate)
			if (exists("oxoPlateSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_oxoPlateSm <<- ResSmooth
				TEMPChecksums$Data_oxoPlateSm[1] <<- sum(colSums(Data_oxoPlate))
				TEMPChecksums$Data_oxoPlateSm[2] <<- sum(colSums(Data_oxoPlateSm))
				print("Data oxoPlate smoothed")
				print(Data_oxoPlateSm[1:10,])
				## remove variable to prevent rerun complication
				rm(oxoPlateSmoothReplace)
			}
			Data_oxoPlateSlope <<- ResSlope
			TEMPChecksums$Data_oxoPlateSlope[1] <<- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSlope[2] <<- sum(colSums(Data_oxoPlateSlope))
			Data_oxoPlateSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_oxoPlateSlopeSd[1] <<- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSlopeSd[2] <<- sum(colSums(Data_oxoPlateSlopeSd))
			print("Data oxoPlate slope")
			print(Data_oxoPlateSlope[1:10,])
			print("Data oxoPlate slope deviation")
			print(Data_oxoPlateSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoPlate consumption
		if (SETAnalysisOpt$ConsSelection["Data_oxoPlate"] == TRUE & TEMPChecksums$Data_oxoPlateSlope[2] != TEMPChecksums$Data_oxoPlateCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_oxoPlate, Data_oxoPlateSlope)
			Data_oxoPlateCons <<- ResCons
			TEMPChecksums$Data_oxoPlateCons[1] <<- sum(colSums(Data_oxoPlateSlope))
			TEMPChecksums$Data_oxoPlateCons[2] <<- sum(colSums(Data_oxoPlateCons))
			Data_oxoPlateConsSd <<- ResConsSd
			TEMPChecksums$Data_oxoPlateConsSd[1] <<- sum(colSums(Data_oxoPlateSlope))
			TEMPChecksums$Data_oxoPlateConsSd[2] <<- sum(colSums(Data_oxoPlateConsSd))
			print("Data consumption from oxoPlate")
			print(Data_oxoPlateCons[1:10,])
			print("Data consumption from oxoPlate deviation")
			print(Data_oxoPlateConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	## OxoPlate average
	if (SETAnalysisOpt$oxoPlate[2] == TRUE & SETAnalysisOpt$oxoPlate[1] == TRUE) {
		if (TEMPChecksums$Data_oxoPlate[2] != TEMPChecksums$Data_oxoPlateAv[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating average calibrated data")
			FCalculationAverage(Data_oxoPlate)
			Data_oxoPlateAv <<- Res
			TEMPChecksums$Data_oxoPlateAv[1] <<- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateAv[2] <<- sum(colSums(Data_oxoPlateAv))
			print("Data oxoPlate av")
			print(Data_oxoPlateAv[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoPlate standarddeviation
		if (SETAnalysisOpt$SD == TRUE & TEMPChecksums$Data_oxoPlate[2] != TEMPChecksums$Data_oxoPlateSd[1]) {
			FCalculationStandarddev(Data_oxoPlate)
			Data_oxoPlateSd <<- Res
			TEMPChecksums$Data_oxoPlateSd[1] <<- sum(colSums(Data_oxoPlate))
			TEMPChecksums$Data_oxoPlateSd[2] <<- sum(colSums(Data_oxoPlateSd))
			print("Data oxoPlate sd")
			print(Data_oxoPlateSd[1:10,])
		}
		## OxoPlate average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_oxoPlateAv"]] == TRUE & TEMPChecksums$Data_oxoPlateAv[2] != TEMPChecksums$Data_oxoPlateAvSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_oxoPlateAv"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_oxoPlateAv)
				Data_oxoPlateAvSm <<- ResSmooth
				TEMPChecksums$Data_oxoPlateAvSm[1] <<- sum(colSums(Data_oxoPlateAv))
				TEMPChecksums$Data_oxoPlateAvSm[2] <<- sum(colSums(Data_oxoPlateAvSm))
				print("Data oxoPlate av smoothed")
				print(Data_oxoPlateAvSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				oxoPlateAvSmoothReplace <- TRUE
			}
		}
		## OxoPlate average slope
		if (SETAnalysisOpt$slopeSelection[["Data_oxoPlateAv"]] == TRUE & TEMPChecksums$Data_oxoPlateAv[2] != TEMPChecksums$Data_oxoPlateAvSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_oxoPlateAv)
			if (exists("oxoPlateAvSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_oxoPlateAvSm <<- ResSmooth
				TEMPChecksums$Data_oxoPlateAvSm[1] <<- sum(colSums(Data_oxoPlateAv))
				TEMPChecksums$Data_oxoPlateAvSm[2] <<- sum(colSums(Data_oxoPlateAvSm))
				print("Data oxoPlate av smoothed")
				print(Data_oxoPlateAvSm[1:10,])
				## remove variable to prevent rerun complication
				rm(oxoPlateAvSmoothReplace)
			}
			Data_oxoPlateAvSlope <<- ResSlope
			TEMPChecksums$Data_oxoPlateAvSlope[1] <<- sum(colSums(Data_oxoPlateAv))
			TEMPChecksums$Data_oxoPlateAvSlope[2] <<- sum(colSums(Data_oxoPlateAvSlope))
			Data_oxoPlateAvSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_oxoPlateAvSlopeSd[1] <<- sum(colSums(Data_oxoPlateAv))
			TEMPChecksums$Data_oxoPlateAvSlopeSd[2] <<- sum(colSums(Data_oxoPlateAvSlopeSd))
			print("Data oxoPlate av slope")
			print(Data_oxoPlateAvSlope[1:10,])
			print("Data oxoPlate av slope deviation")
			print(Data_oxoPlateAvSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## OxoPlate average consumption
		if (SETAnalysisOpt$ConsSelection["Data_oxoPlateAv"] == TRUE & TEMPChecksums$Data_oxoPlateAvSlope[2] != TEMPChecksums$Data_oxoPlateAvCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_oxoPlateAv, Data_oxoPlateAvSlope, Data_oxoPlateSd)
			Data_oxoPlateAvCons <<- ResCons
			TEMPChecksums$Data_oxoPlateAvCons[1] <<- sum(colSums(Data_oxoPlateAvSlope))
			TEMPChecksums$Data_oxoPlateAvCons[2] <<- sum(colSums(Data_oxoPlateAvCons))
			Data_oxoPlateAvConsSd <<- ResConsSd
			TEMPChecksums$Data_oxoPlateAvConsSd[1] <<- sum(colSums(Data_oxoPlateAvSlope))
			TEMPChecksums$Data_oxoPlateAvConsSd[2] <<- sum(colSums(Data_oxoPlateAvConsSd))
			print("Data consumption from oxoPlate av")
			print(Data_oxoPlateAvCons[1:10,])
			print("Data consumption from oxoPlate av deviation")
			print(Data_oxoPlateAvConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	
	## HydroPlate conversion
	if (SETAnalysisOpt$hydroPlate[1] == TRUE) {
		if (TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_hydroPlate[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalibrating HydroPlate data")
			FCalculationHydroPlate()
			TEMPChecksums$Data_hydroPlate[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_hydroPlate[2] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateCal[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_hydroPlateCal[2] <<- sum(colSums(Data_hydroPlateCal))
			print("Data hydroPlate")
			print(Data_hydroPlate[1:10,])
			print("Data hydroPlate calibration values")
			print(Data_hydroPlateCal[1:10,])
			Data_hydroPlateOrig <<- data.frame()
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		if (length(Data_hydroPlateOrig[1,1]) != 0) Data_hydroPlate <<- Data_hydroPlateOrig
		if (length(SETAnalysisOpt$Formatting) != 0) {
			## hydroPlate formatting
			if (SETAnalysisOpt$Formatting == "Data_hydroPlate") {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
				if (length(Data_hydroPlateOrig[1,1]) == 0) {
					Data_hydroPlateOrig <<- Data_hydroPlate
					TEMPChecksums$Data_hydroPlateOrig[1] <<- sum(colSums(Data_raw))
					TEMPChecksums$Data_hydroPlateOrig[2] <<- sum(colSums(Data_hydroPlateOrig))
				}
				FCalculationFormatting(Data_hydroPlate)
				Data_hydroPlate <<- ResFormat
				TEMPChecksums$Data_hydroPlate[2] <<- sum(colSums(Data_hydroPlate))
				print("Data hydroPlate formatted")
				print(Data_hydroPlate[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			}
		}
		## HydroPlate smooth
		if (SETAnalysisOpt$smoothSelection[["Data_hydroPlate"]] == TRUE & TEMPChecksums$Data_hydroPlate[2] != TEMPChecksums$Data_hydroPlateSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_hydroPlate"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_hydroPlate)
				Data_hydroPlateSm <<- ResSmooth
				TEMPChecksums$Data_hydroPlateSm[1] <<- sum(colSums(Data_hydroPlate))
				TEMPChecksums$Data_hydroPlateSm[2] <<- sum(colSums(Data_hydroPlateSm))
				print("Data hydroPlate smoothed")
				print(Data_hydroPlateSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				hydroPlateSmoothReplace <- TRUE
			}
		}
		## HydroPlate slope
		if (SETAnalysisOpt$slopeSelection[["Data_hydroPlate"]] == TRUE & TEMPChecksums$Data_hydroPlate[2] != TEMPChecksums$Data_hydroPlateSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_hydroPlate)
			if (exists("hydroPlateSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_hydroPlateSm <<- ResSmooth
				TEMPChecksums$Data_hydroPlateSm[1] <<- sum(colSums(Data_hydroPlate))
				TEMPChecksums$Data_hydroPlateSm[2] <<- sum(colSums(Data_hydroPlateSm))
				print("Data hydroPlate smoothed")
				print(Data_hydroPlateSm[1:10,])
				## remove variable to prevent rerun complication
				rm(hydroPlateSmoothReplace)
			}
			Data_hydroPlateSlope <<- ResSlope
			TEMPChecksums$Data_hydroPlateSlope[1] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSlope[2] <<- sum(colSums(Data_hydroPlateSlope))
			Data_hydroPlateSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_hydroPlateSlopeSd[1] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSlopeSd[2] <<- sum(colSums(Data_hydroPlateSlopeSd))
			print("Data hydroPlate slope")
			print(Data_hydroPlateSlope[1:10,])
			print("Data hydroPlate slope deviation")
			print(Data_hydroPlateSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	## HydroPlate average
	if (SETAnalysisOpt$hydroPlate[2] == TRUE & SETAnalysisOpt$hydroPlate[1] == TRUE) {
		if (TEMPChecksums$Data_hydroPlate[2] != TEMPChecksums$Data_hydroPlateAv[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating average calibrated data")
			FCalculationAverage(Data_hydroPlate)
			Data_hydroPlateAv <<- Res
			TEMPChecksums$Data_hydroPlateAv[1] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateAv[2] <<- sum(colSums(Data_hydroPlateAv))
			print("Data hydroPlate av")
			print(Data_hydroPlateAv[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## HydroPlate standarddeviation
		if (SETAnalysisOpt$SD == TRUE & TEMPChecksums$Data_hydroPlate[2] != TEMPChecksums$Data_hydroPlateSd[1]) {
			FCalculationStandarddev(Data_hydroPlate)
			Data_hydroPlateSd <<- Res
			TEMPChecksums$Data_hydroPlateSd[1] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateSd[2] <<- sum(colSums(Data_hydroPlateSd))
			print("Data hydroPlate sd")
			print(Data_hydroPlateSd[1:10,])
		}
		## HydroPlate average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_hydroPlateAv"]] == TRUE & TEMPChecksums$Data_hydroPlateAv[2] != TEMPChecksums$Data_hydroPlateAvSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_hydroPlateAv"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_hydroPlateAv)
				Data_hydroPlateAvSm <<- ResSmooth
				TEMPChecksums$Data_hydroPlateAvSm[1] <<- sum(colSums(Data_hydroPlateAv))
				TEMPChecksums$Data_hydroPlateAvSm[2] <<- sum(colSums(Data_hydroPlateAvSm))
				print("Data hydroPlate av smoothed")
				print(Data_hydroPlateAvSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				hydroPlateAvSmoothReplace <- TRUE
			}
		}
		## HydroPlate average slope
		if (SETAnalysisOpt$slopeSelection[["Data_hydroPlateAv"]] == TRUE & TEMPChecksums$Data_hydroPlateAv[2] != TEMPChecksums$Data_hydroPlateAvSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_hydroPlateAv)
			if (exists("hydroPlateAvSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_hydroPlateAvSm <<- ResSmooth
				TEMPChecksums$Data_hydroPlateAvSm[1] <<- sum(colSums(Data_hydroPlateAv))
				TEMPChecksums$Data_hydroPlateAvSm[2] <<- sum(colSums(Data_hydroPlateAvSm))
				print("Data hydroPlate av smoothed")
				print(Data_hydroPlateAvSm[1:10,])
				## remove variable to prevent rerun complication
				rm(hydroPlateAvSmoothReplace)
			}
			Data_hydroPlateAvSlope <<- ResSlope
			TEMPChecksums$Data_hydroPlateAvSlope[1] <<- sum(colSums(Data_hydroPlateAv))
			TEMPChecksums$Data_hydroPlateAvSlope[2] <<- sum(colSums(Data_hydroPlateAvSlope))
			Data_hydroPlateAvSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_hydroPlateAvSlopeSd[1] <<- sum(colSums(Data_hydroPlateAv))
			TEMPChecksums$Data_hydroPlateAvSlopeSd[2] <<- sum(colSums(Data_hydroPlateAvSlopeSd))
			print("Data hydroPlate av slope")
			print(Data_hydroPlateAvSlope[1:10,])
			print("Data hydroPlate av slope deviation")
			print(Data_hydroPlateAvSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	
	## medium normalisation
	if (SETAnalysisOpt$medium[1] == TRUE) {
		if (SETAnalysisOpt$oxoDish[1] == TRUE & TEMPChecksums$Data_oxoDish[2] != TEMPChecksums$Data_medium[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nNormalising data to normalisation condition")
			FCalculationMedium(Data_oxoDish)
			TEMPChecksums$Data_medium[1] <<- sum(colSums(Data_oxoDish))
			TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
			print("Data normalisation")
			print(Data_medium[1:10,])
			Data_mediumOrig <<- data.frame()
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		} else if (SETAnalysisOpt$oxoDish[1] == FALSE & TEMPChecksums$Data_raw[2] != TEMPChecksums$Data_medium[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nNormalising data to normalisation condition")
			FCalculationMedium(Data_raw)
			TEMPChecksums$Data_medium[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
			print("Data normalisation")
			print(Data_medium[1:10,])
			Data_mediumOrig <<- data.frame()
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		if (length(Data_mediumOrig[1,1]) != 0) Data_medium <<- Data_mediumOrig
		if (length(SETAnalysisOpt$Formatting) != 0) {
			## medium formatting
			if (SETAnalysisOpt$oxoDish[1] == TRUE & SETAnalysisOpt$Formatting == "Data_medium") {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
				if (length(Data_mediumOrig[1,1]) == 0) {
					Data_mediumOrig <<- Data_medium
					TEMPChecksums$Data_mediumOrig[1] <<- sum(colSums(Data_oxoDish))
					TEMPChecksums$Data_mediumOrig[2] <<- sum(colSums(Data_mediumOrig))
				}
				FCalculationFormatting(Data_medium)
				Data_medium <<- ResFormat
				TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
				print("Data normalisation formatted")
				print(Data_medium[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else if (SETAnalysisOpt$oxoDish[1] == FALSE & SETAnalysisOpt$Formatting == "Data_medium") {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > formatting data set")
				if (length(Data_mediumOrig[1,1]) == 0) {
					Data_mediumOrig <<- Data_medium
					TEMPChecksums$Data_mediumOrig[1] <<- sum(colSums(Data_raw))
					TEMPChecksums$Data_mediumOrig[2] <<- sum(colSums(Data_mediumOrig))
				}
				FCalculationFormatting(Data_medium)
				Data_medium <<- ResFormat
				TEMPChecksums$Data_medium[2] <<- sum(colSums(Data_medium))
				print("Data normalisation formatted")
				print(Data_medium[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			}
		}
		## medium smooth
		if (SETAnalysisOpt$smoothSelection[["Data_medium"]] == TRUE & TEMPChecksums$Data_medium[2] != TEMPChecksums$Data_mediumSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_medium"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_medium)
				Data_mediumSm <<- ResSmooth
				TEMPChecksums$Data_mediumSm[1] <<- sum(colSums(Data_medium))
				TEMPChecksums$Data_mediumSm[2] <<- sum(colSums(Data_mediumSm))
				print("Data normalisation smoothed")
				print(Data_mediumSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				mediumSmoothReplace <- TRUE
			}
		}
		## medium slope
		if (SETAnalysisOpt$slopeSelection[["Data_medium"]] == TRUE & TEMPChecksums$Data_medium[2] != TEMPChecksums$Data_mediumSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_medium)
			if (exists("mediumSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_mediumSm <<- ResSmooth
				TEMPChecksums$Data_mediumSm[1] <<- sum(colSums(Data_medium))
				TEMPChecksums$Data_mediumSm[2] <<- sum(colSums(Data_mediumSm))
				print("Data normalisation smoothed")
				print(Data_mediumSm[1:10,])
				## remove variable to prevent rerun complication
				rm(mediumSmoothReplace)
			}
			Data_mediumSlope <<- ResSlope
			TEMPChecksums$Data_mediumSlope[1] <<- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSlope[2] <<- sum(colSums(Data_mediumSlope))
			Data_mediumSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_mediumSlopeSd[1] <<- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSlopeSd[2] <<- sum(colSums(Data_mediumSlopeSd))
			print("Data normalisation slope")
			print(Data_mediumSlope[1:10,])
			print("Data normalisation slope deviation")
			print(Data_mediumSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## medium consumption
		if (SETAnalysisOpt$ConsSelection["Data_medium"] == TRUE & TEMPChecksums$Data_mediumSlope[2] != TEMPChecksums$Data_mediumCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_medium, Data_mediumSlope)
			Data_mediumCons <<- ResCons
			TEMPChecksums$Data_mediumCons[1] <<- sum(colSums(Data_mediumSlope))
			TEMPChecksums$Data_mediumCons[2] <<- sum(colSums(Data_mediumCons))
			Data_mediumConsSd <<- ResConsSd
			TEMPChecksums$Data_mediumConsSd[1] <<- sum(colSums(Data_mediumSlope))
			TEMPChecksums$Data_mediumConsSd[2] <<- sum(colSums(Data_mediumConsSd))
			print("Data consumption from normalisation")
			print(Data_mediumCons[1:10,])
			print("Data consumption from normalisation deviation")
			print(Data_mediumConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	## medium average
	if (SETAnalysisOpt$medium[2] == TRUE & SETAnalysisOpt$medium[1] == TRUE) {
		if (TEMPChecksums$Data_medium[2] != TEMPChecksums$Data_mediumAv[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating average normalisation data")
			FCalculationAverage(Data_medium)
			Data_mediumAv <<- Res
			TEMPChecksums$Data_mediumAv[1] <<- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumAv[2] <<- sum(colSums(Data_mediumAv))
			print("Data normalisation av")
			print(Data_mediumAv[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## medium standarddeviation
		if (SETAnalysisOpt$SD == TRUE & TEMPChecksums$Data_medium[2] != TEMPChecksums$Data_mediumSd[1]) {
			FCalculationStandarddev(Data_medium)
			Data_mediumSd <<- Res
			TEMPChecksums$Data_mediumSd[1] <<- sum(colSums(Data_medium))
			TEMPChecksums$Data_mediumSd[2] <<- sum(colSums(Data_mediumSd))
			print("Data normalisation sd")
			print(Data_mediumSd[1:10,])
		}
		## medium average smooth
		if (SETAnalysisOpt$smoothSelection[["Data_mediumAv"]] == TRUE & TEMPChecksums$Data_mediumAv[2] != TEMPChecksums$Data_mediumAvSm[1]) {
			if (SETAnalysisOpt$slopeSelection[["Data_mediumAv"]] == FALSE | SETAnalysisOpt$smoothParam[2] != SETAnalysisOpt$slopeParam[3]) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > smoothing")
				FCalculationSmooth(Data_mediumAv)
				Data_mediumAvSm <<- ResSmooth
				TEMPChecksums$Data_mediumAvSm[1] <<- sum(colSums(Data_mediumAv))
				TEMPChecksums$Data_mediumAvSm[2] <<- sum(colSums(Data_mediumAvSm))
				print("Data normalisation av smoothed")
				print(Data_mediumAvSm[1:10,])
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
			} else {
				mediumAvSmoothReplace <- TRUE
			}
		}
		## medium average slope
		if (SETAnalysisOpt$slopeSelection[["Data_mediumAv"]] == TRUE & TEMPChecksums$Data_mediumAv[2] != TEMPChecksums$Data_mediumAvSlope[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > slope calculation")
			FCalculationSlope(Data_mediumAv)
			if (exists("mediumAvSmoothReplace") == TRUE) {
				POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " + smoothing")
				Data_mediumAvSm <<- ResSmooth
				TEMPChecksums$Data_mediumAvSm[1] <<- sum(colSums(Data_mediumAv))
				TEMPChecksums$Data_mediumAvSm[2] <<- sum(colSums(Data_mediumAvSm))
				print("Data normalisation av smoothed")
				print(Data_mediumAvSm[1:10,])
				## remove variable to prevent rerun complication
				rm(mediumAvSmoothReplace)
			}
			Data_mediumAvSlope <<- ResSlope
			TEMPChecksums$Data_mediumAvSlope[1] <<- sum(colSums(Data_mediumAv))
			TEMPChecksums$Data_mediumAvSlope[2] <<- sum(colSums(Data_mediumAvSlope))
			Data_mediumAvSlopeSd <<- ResSlopeSd
			TEMPChecksums$Data_mediumAvSlopeSd[1] <<- sum(colSums(Data_mediumAv))
			TEMPChecksums$Data_mediumAvSlopeSd[2] <<- sum(colSums(Data_mediumAvSlopeSd))
			print("Data normalisation av slope")
			print(Data_mediumAvSlope[1:10,])
			print("Data normalisation av slope deviation")
			print(Data_mediumAvSlopeSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
		## medium average consumption
		if (SETAnalysisOpt$ConsSelection["Data_mediumAv"] == TRUE & TEMPChecksums$Data_mediumAvSlope[2] != TEMPChecksums$Data_mediumAvCons[1]) {
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\t > oxygen consumption")
			FCalculationCons(Data_mediumAv, Data_mediumAvSlope, Data_mediumSd)
			Data_mediumAvCons <<- ResCons
			TEMPChecksums$Data_mediumAvCons[1] <<- sum(colSums(Data_mediumAvSlope))
			TEMPChecksums$Data_mediumAvCons[2] <<- sum(colSums(Data_mediumAvCons))
			Data_mediumAvConsSd <<- ResConsSd
			TEMPChecksums$Data_mediumAvConsSd[1] <<- sum(colSums(Data_mediumAvSlope))
			TEMPChecksums$Data_mediumAvConsSd[2] <<- sum(colSums(Data_mediumAvConsSd))
			print("Data consumption from normalisation av")
			print(Data_mediumAvCons[1:10,])
			print("Data consumption from normalisation av deviation")
			print(Data_mediumAvConsSd[1:10,])
			POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
		}
	}
	if (SETAnalysisOpt$IC50calc == TRUE) {
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], "\n\nCalculating IC50")
		FCalculationIC50()
		TEMPChecksums$Data_IC50[1] <<- sum(colSums(get(SETAnalysisOpt$IC50)))
		TEMPChecksums$Data_IC50[2] <<- sum(colSums(Data_IC50))
		print("IC50 data")
		print(Data_IC50[1:10,])
		TEMPChecksums$Data_IC50Models[1] <<- sum(colSums(get(SETAnalysisOpt$IC50)))
		TEMPChecksums$Data_IC50Models[2] <<- sum(as.numeric(names(Data_IC50Models)))
		print("IC50 fitting data")
		print(Data_IC50Models[1:3])
		POPAnalysisRunning["text"] <- paste0(POPAnalysisRunning["text"], " - done")
	}
	SETGraphOutput <<- list(Scalebar = SETGraphOutput$Scalebar, 
							IC50 = SETGraphOutput$IC50)
}